(ns scrum-tools.io.jira
  (:require [clojure.xml :as xml]
            [clojure.edn :as edn]
            [clojure.data.json :as json]))

(defn- channel [rss-data]
  (-> rss-data :content first :content))

(defn- filter-items [channel-data]
  (map #(:content %) (filter #(= (:tag %) :item) channel-data)))

(defn- convert-tag [{:keys [tag attrs content] :as elem}]
  ;; TODO: convert recursively to flatten the customfields structure
  [tag {:attrs attrs :content (if (= (count content) 1) (first content) content)}])

(defn- convert-tags [item]
  (map convert-tag item))

(defn- to-map [item]
  (reduce #(assoc %1 (first %2) (second %2)) {} item))

(defn- convert-items [items]
  (map to-map (map convert-tags items)))

(defn- customfield-value [fieldname fields]
  ;; TODO: adapt the lookup to new structure after 'convert-tag' works recursively
  (-> (filter #(= (-> % :content first :content first) fieldname) fields)
      first :content second :content first :content first ))

(defn items
  "Gets the 'item' elements out of jira search rss result and converts them to maps.

  The xml structure is:
  rss -> channel ->
  title | link | description | language | issue | build-info | item [n times]"
  [rss-data]
  (-> rss-data channel filter-items convert-items))

(defn collect-stats
  "Extracts relevant data out of a single item as generated by the 'items' function"
  [{:keys [key summary description reporter priority status timespent assignee] :as item}]
  {:key (:content key)
   :summary (:content summary)
;   :description (:content description)
   :reporter (:content reporter)
   :priority (:content priority)
   :status (:content status)
   :time-spent-minutes (/ (edn/read-string (-> timespent :attrs :seconds)) 60)
   :assignee (:content assignee)
   :resolved-by (customfield-value "Resolved by" (-> item :customfields :content))})
